{% extends 'core/base_bs.html' %}
{% load humanize %}
{% load i18n static %}

{% block meta %}
    {{ block.super }}
    <meta name="copyright" content="New Cameroon">
    <meta name="abstract" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta name="description" content="{% trans "Take action to be part of new Cameroon ahead. It starts by registration on the electoral file. Find a spot near you, share and help other people find theirs." %}"/>

    <meta property="og:type" content="website"/>
    <meta property="og:site_name" content="New Cameroon">
    <meta property="og:title" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta property="og:description" content="{% trans "Find the nearest ELECAM registration spot." %}"/>
    <meta property="og:url" content="{% url 'home' %}"/>
    <meta property="og:image" content="{% static 'newcameroon/img/ballot.jpg' %}"/>
{% endblock %}

{% block page_title %}
    <title>{% trans "Act! Be part of the change." %}</title>
{% endblock %}

{% block head_style %}
    {{ block.super }}
    <link rel="stylesheet" href="{% static 'newcameroon/css/registration.css' %}?v=25.2.9">
{% endblock %}

{% block content %}
    <div class="container">
        <div class="page-header text-center">
            <img src="{% static 'newcameroon/img/cameroon-flag.jpg' %}" alt="Cameroon flag" />
            <div class="page-title" style="margin: 20px 0 0 10px">New Cameroon</div>
            <div class="clearfix"></div>
        </div>
        <p class="text-muted col-sm-offset-2 col-md-offset-3 col-sm-8 col-md-6 text-center page-summary">{% trans "Take action to be part of the new Cameroon ahead. It starts by registration on the electoral file. Find a spot near you, share and help other people find theirs." %}</p>
        <div class="section-header">
            <img src="{% static 'newcameroon/img/ballot.jpg' %}" alt="transparent ballot" />
            <h1 class="section-title">{% trans "Find the nearest ELECAM registration spot." %}</h1>
            <div class="clearfix"></div>
        </div>
        <div class="col-sm-10 col-md-8 col-sm-offset-1 col-md-offset-2">
            <form class="row" style="margin-top: 10px">
                <div class="form-group">
                    <label for="city">{% trans "City" %}</label>
                    <input type="text" id="city" class="form-control" autofocus />
                    <div class="results cities has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="city ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div class="form-group">
                    <label for="hood">{% trans "Hood" %}</label>
                    <input type="text" id="hood" class="form-control" disabled />
                    <div class="results hoods has-shade" style="display: none; max-height: 300px; overflow: auto"
                         data-min-search-chars="3">
                        {% include 'core/snippets/spinner.html' %}
                        <ul class="object-list" style="padding-left: 0">
                            <li class="hood ik-li tpl" style="display: none">
                                <div class="name"></div>
                            </li>
                            <li class="ik-li">
                                <div class="name">
                                    <a href="{% url "changespot:remind_me" %}">
                                        {% trans "I can't find my hood, please remind me when it's available" %}
                                    </a>
                                </div>
                            </li>
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
                <div id="results">
                    {% include 'core/snippets/spinner.html' %}
                    <div class="spot tpl">
                        <span class="spot-name"></span>
                        <a class="share-spot" href="javascript:;" title="{% trans "Share" %}">
                            <i class="fa fa-share-alt"></i>
                        </a>
                        <div class="place has-shade">
                            <div class="close">
                                <i class="fa fa-times pull-right"></i>
                                <div class="clearfix"></div>
                            </div>
                            <div class="detail text-muted"></div>
                        </div>
                    </div>
                    <div class="clearfix"></div>
                </div>
                <div id="no-results" class="text-center" style="display: none">
                    <h4>{% trans "Sorry! No spot found there." %}</h4>
                    <p>{% trans "Come back later. New spots are added everyday." %}</p>
                    <p>{% trans "Let us remind remind you when one is available. New spots are added everyday." %}</p>
                    <a href="#" class="btn btn-green" style="min-width: 240px">{% trans "Remind me" %}</a>
                </div>
                <div id="manage-donations" class="text-center" style="display: none">
                    <div style="margin-top: 15px">
                        <p>{% trans "If you like our work, please consider making a donation." %}</p>
                        <a id="show-donate-options" class="btn btn-green" style="margin-bottom: 30px; width: 240px">
                            <span>{% trans "Donate" %}</span>
                        </a>
                    </div>
                    <div class="donations" style="display: none">
                        <h5 style="font-size: 1.1em; font-weight: 700; margin-top: 10px">{% trans "Donate using Orange Money or MTN MoMo" %}</h5>
                        <ul style="margin: 0; padding: 0">
                            {% for suggestion in donate_suggestions %}
                            <li class="payment-start" data-amount="{{ suggestion.amount }}">
                                <div>
                                    <div style="font-size: 30px">{{ suggestion.emote }}{% if forloop.counter == 1 %}&#127996;{% endif %}</div>
                                    <div>
                                        <span class="text-muted currency">XAF</span>
                                        <strong class="amount">{{ suggestion.amount|intcomma }}</strong>
                                    </div>
                                </div>
                            </li>
                            {% endfor %}
                        </ul>
                        <div class="clearfix"></div>
                    </div>
                </div>
            </form>
            <div class="suggest-add-spot row">
                <div class="img col-xs-3 col-md-4" style="padding-right: 5px">
                    <img src="{% static 'newcameroon/img/add-spot.jpg' %}" class="img-responsive" alt="" />
                </div>
                <div class="detail col-xs-9 col-md-8" style="padding-left: 5px">
                    <p>{% trans "Do you know an ELECAM spot not listed here? Help people by adding it." %}</p>
                    <a href="{% url 'changespot:add_spot' %}" class="btn btn-deep-blue">{% trans "Add an ELECAM spot" %}</a>
                </div>
            </div>
        </div>
    </div>
    {% include 'billing/snippets/modal_payment_options.html' %}
{% endblock %}

{% block js %}
    {{ block.super }}
    <script>
        (() => {
            $('body').on('click', '.results.cities li.city', function () {
                let cityId = $(this).prop('id'),
                    cityName = $(this).find('.name').text();
                $('#city').data('id', cityId).val(cityName);
                if (!cityId) {
                    $('#hood').prop('disabled', true).val("");
                    return
                }
                $('.spot:not(.tpl)').remove();
                $.getJSON('', {action: 'list_hoods', city_id: cityId}, function(data) {
                    if (data.length === 0) {
                        $('#no-results').show();
                        $('#no-results a').prop('href', `{% url 'changespot:remind_me' %}?city_id=${cityId}`);
                        $('#hood').prop('disabled', true).val("")
                        $('#city').focus()
                        return
                    }
                    $('#no-results').hide();
                    $('#hood').prop('disabled', false).focus()
                })
            }).on('blur', '#city', function() {
                if ($('.city.ik-li:not(.tpl)').length > 0) $('.city.ik-li:first').click();
            }).on('click', '.results.hoods li.hood', function() {
                let hoodId = $(this).prop('id'),
                    hoodName = $(this).find('.name').text();
                $('#hood').val(hoodName);
                if (hoodId === "") {
                    $('.spot:not(.tpl)').remove();
                    $('#no-results').hide();
                    return
                }
                $('#results .spinner').show();
                $.getJSON('', {action: 'list_spots', hood_id: hoodId}, function(data) {
                    $('#results .spinner').hide();
                    $('#no-results').hide();
                    $('.spot:not(.tpl)').remove();
                    if (data.length === 0) {
                        $('#no-results').show();
                        $('#no-results a').prop('href', `{% url 'changespot:remind_me' %}?hood_id=${hoodId}`);
                        return
                    }
                    for (let i=0; i<data.length; i++) {
                        let $spot = applySpotTpl(data[i])
                        $spot.insertBefore('.spot.tpl')
                    }
                    setTimeout(function() {
                        $("#manage-donations").show()
                        $('.donations').hide()
                    }, 3000)
                })
            }).on('blur', '#hood', function() {
                if ($('.hood.ik-li:not(.tpl)').length > 0) $('.hood.ik-li:first').click();
            }).on('click', '.spot', function() {
                $('.place').hide();
                $(this).find('.place').show();
            }).on('mouseenter', '.spot-name', function() {
                $('.place').hide();
                $(this).parents('.spot').find('.place').show();
            }).on('mouseleave', '.spot', function() {
                $('.place').hide();
            }).on('click', '.close i', function(e) {
                $(this).parents('.place').hide();
                e.stopPropagation()
            }).on('click', '.share-spot', function(e) {
                $(this).parents('.place').hide();
                e.stopPropagation()
            }).on('click', '#show-donate-options', function() {
                $('.donations').show()
            });
            function applySpotTpl(spot) {
                let $tpl = $('.spot.tpl').clone().removeClass('tpl')
                $tpl.find('.spot-name').text(spot.place.substr(0, 12))
                $tpl.find('.place .detail').text(spot.place)
                let cityId = $('#city').val(),
                    hoodId = $('#hood').val(),
                    url = `{{ service.url }}?city=${cityId}&hood=${hoodId}`,
                    msg = "{% trans "Find the nearest ELECAM spot and go get registered." %}";
                $tpl.find('.share-spot').prop('href', 'https://api.whatsapp.com/send?text=' + url + '%0A%0A' + msg)
                return $tpl
            }
            $('#city').focusout(function () {
                $('.results.cities').fadeOut()
            });
            ikwen.setupSearch('#city', '.results.cities', [{
                endpoint: '/?action=list_cities',
                resultTplSelector: '.results.cities li.city',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#city').val().length, 7);
                }
            }]);

            $('#hood').focusout(function () {
                $('.results.hoods').fadeOut()
            });
            ikwen.setupSearch('#hood', '.results.hoods', [{
                endpoint: function() {
                    return `/?action=list_hoods&city_id=${$('#city').data('id')}`
                },
                resultTplSelector: '.results.hoods li.hood',
                searchParam: 'name',
                minChars: 2,
                maxChars: function () {
                    // The max number of characters that will be taken into consideration
                    // in the string typed by user to do the search. Characters above that
                    // limit will be ignored.
                    return Math.max($('#hood').val().length, 7);
                }
            }]);
        })()
    </script>
{% endblock %}